commit f905a3884388b268694cf9411850f887c234e709
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Sat Jul 16 23:45:14 2022 +0200

    cleanup

diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/api/application/CdmIoApplicationController.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/api/application/CdmIoApplicationController.java
index 494b559bd3..dbe357bca2 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/api/application/CdmIoApplicationController.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/api/application/CdmIoApplicationController.java
@@ -1,74 +1,75 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.cdm.io.api.application;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-import org.springframework.core.io.ClassPathResource;
-import org.springframework.core.io.Resource;
-
-import eu.etaxonomy.cdm.api.application.CdmApplicationController;
-import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
-import eu.etaxonomy.cdm.database.DataSourceNotFoundException;
-import eu.etaxonomy.cdm.database.DbSchemaValidation;
-import eu.etaxonomy.cdm.database.ICdmDataSource;
-import eu.etaxonomy.cdm.persistence.hibernate.HibernateConfiguration;
-
-public class CdmIoApplicationController extends CdmApplicationController {
-
-    @SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(CdmIoApplicationController.class);
-
-
-	public static final String DEFAULT_APPLICATION_CONTEXT_RESOURCE = "/eu/etaxonomy/cdm/defaultIoApplicationContext.xml";
-
-
-	public static CdmIoApplicationController NewInstance() throws DataSourceNotFoundException {
-		return CdmIoApplicationController.NewInstance(getDefaultDatasource(), defaultDbSchemaValidation, false);
-	}
-
-	public static CdmIoApplicationController NewInstance(DbSchemaValidation dbSchemaValidation) throws DataSourceNotFoundException {
-		return CdmIoApplicationController.NewInstance(getDefaultDatasource(), dbSchemaValidation, false);
-	}
-
-	/**
-	 * Constructor, opens an spring ApplicationContext by using the according data source and the
-	 * default database schema validation type
-	 * @param dataSource
-	 */
-	public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource) {
-		return CdmIoApplicationController.NewInstance(dataSource, defaultDbSchemaValidation, false);
-	}
-
-
-	public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource, DbSchemaValidation dbSchemaValidation) {
-		return CdmIoApplicationController.NewInstance(dataSource, dbSchemaValidation, false);
-	}
-
-	public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource, DbSchemaValidation dbSchemaValidation,
-	        boolean omitTermLoading) {
-		return NewInstance(dataSource, dbSchemaValidation, null, omitTermLoading);
-	}
-
-    public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource, DbSchemaValidation dbSchemaValidation,
-            HibernateConfiguration hibernateConfig, boolean omitTermLoading) {
-        return new CdmIoApplicationController(getClasspathResource(),dataSource, dbSchemaValidation,
-                hibernateConfig, omitTermLoading, null);
-    }
-
-	protected static ClassPathResource getClasspathResource() {
-		return new ClassPathResource(DEFAULT_APPLICATION_CONTEXT_RESOURCE);
-	}
-
-	protected CdmIoApplicationController(Resource applicationContextResource, ICdmDataSource dataSource,
-	        DbSchemaValidation dbSchemaValidation, HibernateConfiguration hibernateConfig,
-			boolean omitTermLoading, IProgressMonitor progressMonitor) {
-		super(applicationContextResource, dataSource, dbSchemaValidation, hibernateConfig,
-		        omitTermLoading, progressMonitor, null);
-	}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.io.api.application;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+import org.springframework.core.io.ClassPathResource;
+import org.springframework.core.io.Resource;
+
+import eu.etaxonomy.cdm.api.application.CdmApplicationController;
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.DataSourceNotFoundException;
+import eu.etaxonomy.cdm.database.DbSchemaValidation;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.persistence.hibernate.HibernateConfiguration;
+
+public class CdmIoApplicationController extends CdmApplicationController {
+
+    @SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
+
+
+	public static final String DEFAULT_APPLICATION_CONTEXT_RESOURCE = "/eu/etaxonomy/cdm/defaultIoApplicationContext.xml";
+
+
+	public static CdmIoApplicationController NewInstance() throws DataSourceNotFoundException {
+		return CdmIoApplicationController.NewInstance(getDefaultDatasource(), defaultDbSchemaValidation, false);
+	}
+
+	public static CdmIoApplicationController NewInstance(DbSchemaValidation dbSchemaValidation) throws DataSourceNotFoundException {
+		return CdmIoApplicationController.NewInstance(getDefaultDatasource(), dbSchemaValidation, false);
+	}
+
+	/**
+	 * Constructor, opens an spring ApplicationContext by using the according data source and the
+	 * default database schema validation type
+	 * @param dataSource
+	 */
+	public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource) {
+		return CdmIoApplicationController.NewInstance(dataSource, defaultDbSchemaValidation, false);
+	}
+
+
+	public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource, DbSchemaValidation dbSchemaValidation) {
+		return CdmIoApplicationController.NewInstance(dataSource, dbSchemaValidation, false);
+	}
+
+	public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource, DbSchemaValidation dbSchemaValidation,
+	        boolean omitTermLoading) {
+		return NewInstance(dataSource, dbSchemaValidation, null, omitTermLoading);
+	}
+
+    public static CdmIoApplicationController NewInstance(ICdmDataSource dataSource, DbSchemaValidation dbSchemaValidation,
+            HibernateConfiguration hibernateConfig, boolean omitTermLoading) {
+        return new CdmIoApplicationController(getClasspathResource(),dataSource, dbSchemaValidation,
+                hibernateConfig, omitTermLoading, null);
+    }
+
+	protected static ClassPathResource getClasspathResource() {
+		return new ClassPathResource(DEFAULT_APPLICATION_CONTEXT_RESOURCE);
+	}
+
+	protected CdmIoApplicationController(Resource applicationContextResource, ICdmDataSource dataSource,
+	        DbSchemaValidation dbSchemaValidation, HibernateConfiguration hibernateConfig,
+			boolean omitTermLoading, IProgressMonitor progressMonitor) {
+		super(applicationContextResource, dataSource, dbSchemaValidation, hibernateConfig,
+		        omitTermLoading, progressMonitor, null);
+	}
 }
\ No newline at end of file
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/BerlinModelTransformer.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/BerlinModelTransformer.java
index f8ef8b432a..982ac07ce7 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/BerlinModelTransformer.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/BerlinModelTransformer.java
@@ -12,7 +12,8 @@ import java.sql.ResultSet;
 import java.sql.SQLException;
 import java.util.UUID;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.ResultWrapper;
 import eu.etaxonomy.cdm.model.common.Language;
@@ -42,7 +43,8 @@ import eu.etaxonomy.cdm.strategy.exceptions.UnknownCdmTypeException;
  * @since 20.03.2008
  */
 public class BerlinModelTransformer {
-	private static final Logger logger = LogManager.getLogger(BerlinModelTransformer.class);
+
+	private static final Logger logger = LogManager.getLogger();
 
 	//source Refs
 	public static final UUID uuidSourceRefEuroMed = UUID.fromString("0603a84a-f024-4454-ab92-9e2ac0139126");
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmDescriptionImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmDescriptionImport.java
index dbf07d9213..e4227958b0 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmDescriptionImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmDescriptionImport.java
@@ -11,7 +11,8 @@ package eu.etaxonomy.cdm.io.cdm2cdm;
 import java.util.HashSet;
 import java.util.Set;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 import org.springframework.stereotype.Component;
 import org.springframework.transaction.TransactionStatus;
 
@@ -29,7 +30,7 @@ public class Cdm2CdmDescriptionImport
         extends Cdm2CdmImportBase {
 
     private static final long serialVersionUID = -2111102574346601573L;
-    private static final Logger logger = LogManager.getLogger(Cdm2CdmDescriptionImport.class);
+    private static final Logger logger = LogManager.getLogger();
 
     @Override
     protected void doInvoke(Cdm2CdmImportState state) {
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmImportBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmImportBase.java
index 37e9904d75..2c79c3fece 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmImportBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmImportBase.java
@@ -20,7 +20,8 @@ import java.util.Map;
 import java.util.Set;
 import java.util.UUID;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 
 import eu.etaxonomy.cdm.api.application.CdmApplicationController;
 import eu.etaxonomy.cdm.api.application.ICdmRepository;
@@ -125,7 +126,7 @@ public abstract class Cdm2CdmImportBase
         extends CdmImportBase<Cdm2CdmImportConfigurator, Cdm2CdmImportState> {
 
     private static final long serialVersionUID = 1344722304369624443L;
-    private static final Logger logger = LogManager.getLogger(Cdm2CdmImportBase.class);
+    private static final Logger logger = LogManager.getLogger();
 
     //quick and dirty
     private Cdm2CdmImportState stateX;
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmTaxonNodeImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmTaxonNodeImport.java
index a5cb8fdf27..56206ab5ca 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmTaxonNodeImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmTaxonNodeImport.java
@@ -8,7 +8,8 @@
 */
 package eu.etaxonomy.cdm.io.cdm2cdm;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 import org.springframework.stereotype.Component;
 import org.springframework.transaction.TransactionStatus;
 
@@ -25,7 +26,7 @@ public class Cdm2CdmTaxonNodeImport
         extends Cdm2CdmImportBase {
 
     private static final long serialVersionUID = -2111102574346601573L;
-    private static final Logger logger = LogManager.getLogger(Cdm2CdmTaxonNodeImport.class);
+    private static final Logger logger = LogManager.getLogger();
 
 
     @Override
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmVocabularyImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmVocabularyImport.java
index 181c153395..ebfc966433 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmVocabularyImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/cdm2cdm/Cdm2CdmVocabularyImport.java
@@ -12,7 +12,8 @@ import java.util.List;
 import java.util.Set;
 import java.util.UUID;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 import org.springframework.stereotype.Component;
 import org.springframework.transaction.TransactionStatus;
 
@@ -33,7 +34,7 @@ public class Cdm2CdmVocabularyImport
         extends Cdm2CdmImportBase {
 
     private static final long serialVersionUID = 3995116783196060465L;
-    private static final Logger logger = LogManager.getLogger(Cdm2CdmVocabularyImport.class);
+    private static final Logger logger = LogManager.getLogger();
 
     @Override
     protected void doInvoke(Cdm2CdmImportState state) {
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/events/LoggingIoObserver.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/events/LoggingIoObserver.java
index 28ddbdbc8f..204231fa27 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/events/LoggingIoObserver.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/events/LoggingIoObserver.java
@@ -1,33 +1,28 @@
-/**
-* Copyright (C) 2009 EDIT
-* European Distributed Institute of Taxonomy 
-* http://www.e-taxonomy.eu
-* 
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.cdm.io.common.events;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.events.IIoEvent;
-import eu.etaxonomy.cdm.io.common.events.IIoObserver;
-
-/**
- * This IoObserver logs all events.
- * @author a.mueller
- * @since 24.06.2011
- *
- */
-public class LoggingIoObserver implements IIoObserver {
-	private static final Logger logger = LogManager.getLogger(LoggingIoObserver.class);
-	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.io.common.IIoObserver#handleEvent(eu.etaxonomy.cdm.io.common.IIoEvent)
-	 */
-	@Override
-	public void handleEvent(IIoEvent event) {
-		logger.warn(event);
-	}
-
-}
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.io.common.events;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+/**
+ * This IoObserver logs all events.
+ *
+ * @author a.mueller
+ * @since 24.06.2011
+ */
+public class LoggingIoObserver implements IIoObserver {
+
+	private static final Logger logger = LogManager.getLogger();
+
+	@Override
+	public void handleEvent(IIoEvent event) {
+		logger.warn(event);
+	}
+}
\ No newline at end of file
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmAttributeMapperBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmAttributeMapperBase.java
index c4760a2c88..2a7f194352 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmAttributeMapperBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmAttributeMapperBase.java
@@ -1,44 +1,46 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping;
-
-import java.util.List;
-import java.util.Set;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.common.CdmUtils;
-
-/**
- * A mapper base class for all mappers mapping source attributes to destination attributes.
- *
- * @author a.mueller
- * @since 05.08.2008
- */
-public abstract class CdmAttributeMapperBase extends CdmMapperBase{
-	@SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(CdmAttributeMapperBase.class);
-
-	public abstract Set<String> getSourceAttributes();
-
-	public abstract Set<String> getDestinationAttributes();
-
-	public abstract List<String> getSourceAttributeList();
-
-	public abstract List<String> getDestinationAttributeList();
-
-	@Override
-    public String toString(){
-		String sourceAtt = CdmUtils.concat(",", getSourceAttributeList().toArray(new String[1]));
-		String destAtt = CdmUtils.concat(",", getDestinationAttributeList().toArray(new String[1]));
-		return this.getClass().getSimpleName() +"[" + sourceAtt + "->" + destAtt + "]";
-	}
-
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping;
+
+import java.util.List;
+import java.util.Set;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.CdmUtils;
+
+/**
+ * A mapper base class for all mappers mapping source attributes to destination attributes.
+ *
+ * @author a.mueller
+ * @since 05.08.2008
+ */
+public abstract class CdmAttributeMapperBase extends CdmMapperBase{
+
+	@SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
+
+	public abstract Set<String> getSourceAttributes();
+
+	public abstract Set<String> getDestinationAttributes();
+
+	public abstract List<String> getSourceAttributeList();
+
+	public abstract List<String> getDestinationAttributeList();
+
+	@Override
+    public String toString(){
+		String sourceAtt = CdmUtils.concat(",", getSourceAttributeList().toArray(new String[1]));
+		String destAtt = CdmUtils.concat(",", getDestinationAttributeList().toArray(new String[1]));
+		return this.getClass().getSimpleName() +"[" + sourceAtt + "->" + destAtt + "]";
+	}
+
 }
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmIoMapping.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmIoMapping.java
index 5cdab4c223..c809fb600e 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmIoMapping.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmIoMapping.java
@@ -1,95 +1,95 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping;
-
-import java.util.ArrayList;
-import java.util.HashSet;
-import java.util.List;
-import java.util.Set;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.mapping.out.ObjectChangeMapper;
-
-/**
- * @author a.mueller
- * @since 27.07.2008
- */
-public class CdmIoMapping {
-
-	private static final Logger logger = LogManager.getLogger(CdmIoMapping.class);
-
-	//protected List<CdmAttributeMapperBase> mapperList = new ArrayList<>();
-	protected List<CdmMapperBase> mapperList = new ArrayList<>();
-	Set<String> sourceAttributes = new HashSet<>();
-	Set<String> destinationAttributes = new HashSet<>();
-	List<String> sourceAttributeList = new ArrayList<>();
-	List<String> destinationAttributeList = new ArrayList<>();
-
-	public void addMapper(CdmAttributeMapperBase mapper){
-		if (mapper == null){
-			return;
-		}
-		mapperList.add(mapper);
-		if (mapper instanceof CdmSingleAttributeMapperBase){
-			CdmSingleAttributeMapperBase singleMapper = (CdmSingleAttributeMapperBase)mapper;
-			sourceAttributes.addAll(singleMapper.getSourceAttributes());
-			sourceAttributeList.addAll(singleMapper.getSourceAttributeList());
-			destinationAttributes.addAll(singleMapper.getDestinationAttributes());
-			destinationAttributeList.addAll(singleMapper.getDestinationAttributeList());
-		}else if (mapper instanceof MultipleAttributeMapperBase){
-			MultipleAttributeMapperBase<?> multipleMapper = (MultipleAttributeMapperBase<?>)mapper;
-			sourceAttributes.addAll(multipleMapper.getSourceAttributes());
-			sourceAttributeList.addAll(multipleMapper.getSourceAttributes());
-			destinationAttributes.addAll(multipleMapper.getDestinationAttributes());
-			destinationAttributeList.addAll(multipleMapper.getDestinationAttributeList());
-		}else if (mapper instanceof ObjectChangeMapper){
-			ObjectChangeMapper changeMapper = (ObjectChangeMapper)mapper;
-			sourceAttributes.addAll(changeMapper.getSourceAttributes());
-			sourceAttributeList.addAll(changeMapper.getSourceAttributes());
-			destinationAttributes.addAll(changeMapper.getDestinationAttributes());
-			destinationAttributeList.addAll(changeMapper.getDestinationAttributeList());
-
-		}else{
-			logger.error("Unknown mapper type: " + mapper.getClass().getSimpleName());
-			throw new IllegalArgumentException("Unknown mapper type: " + mapper.getClass().getSimpleName());
-		}
-	}
-
-	public Set<String> getSourceAttributes(){
-		Set<String> result = new HashSet<>();
-		result.addAll(sourceAttributes);
-		return result;
-	}
-
-	public Set<String> getSourceAttributesLowerCase(){
-		Set<String> result = new HashSet<>();
-		for(String attr : sourceAttributes){
-			if (attr != null){
-				result.add(attr.toLowerCase());
-			}else{
-				result.add(null);
-			}
-		}
-		return result;
-	}
-
-	public Set<String> getDestinationAttributes(){
-		Set<String> result = new HashSet<>();
-		result.addAll(destinationAttributes);
-		return result;
-	}
-
-	public List<String> getDestinationAttributeList(){
-		List<String> result = new ArrayList<>();
-		result.addAll(destinationAttributeList);
-		return result;
-	}
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping;
+
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.mapping.out.ObjectChangeMapper;
+
+/**
+ * @author a.mueller
+ * @since 27.07.2008
+ */
+public class CdmIoMapping {
+
+	private static final Logger logger = LogManager.getLogger();
+
+	protected List<CdmMapperBase> mapperList = new ArrayList<>();
+	Set<String> sourceAttributes = new HashSet<>();
+	Set<String> destinationAttributes = new HashSet<>();
+	List<String> sourceAttributeList = new ArrayList<>();
+	List<String> destinationAttributeList = new ArrayList<>();
+
+	public void addMapper(CdmAttributeMapperBase mapper){
+		if (mapper == null){
+			return;
+		}
+		mapperList.add(mapper);
+		if (mapper instanceof CdmSingleAttributeMapperBase){
+			CdmSingleAttributeMapperBase singleMapper = (CdmSingleAttributeMapperBase)mapper;
+			sourceAttributes.addAll(singleMapper.getSourceAttributes());
+			sourceAttributeList.addAll(singleMapper.getSourceAttributeList());
+			destinationAttributes.addAll(singleMapper.getDestinationAttributes());
+			destinationAttributeList.addAll(singleMapper.getDestinationAttributeList());
+		}else if (mapper instanceof MultipleAttributeMapperBase){
+			MultipleAttributeMapperBase<?> multipleMapper = (MultipleAttributeMapperBase<?>)mapper;
+			sourceAttributes.addAll(multipleMapper.getSourceAttributes());
+			sourceAttributeList.addAll(multipleMapper.getSourceAttributes());
+			destinationAttributes.addAll(multipleMapper.getDestinationAttributes());
+			destinationAttributeList.addAll(multipleMapper.getDestinationAttributeList());
+		}else if (mapper instanceof ObjectChangeMapper){
+			ObjectChangeMapper changeMapper = (ObjectChangeMapper)mapper;
+			sourceAttributes.addAll(changeMapper.getSourceAttributes());
+			sourceAttributeList.addAll(changeMapper.getSourceAttributes());
+			destinationAttributes.addAll(changeMapper.getDestinationAttributes());
+			destinationAttributeList.addAll(changeMapper.getDestinationAttributeList());
+
+		}else{
+			logger.error("Unknown mapper type: " + mapper.getClass().getSimpleName());
+			throw new IllegalArgumentException("Unknown mapper type: " + mapper.getClass().getSimpleName());
+		}
+	}
+
+	public Set<String> getSourceAttributes(){
+		Set<String> result = new HashSet<>();
+		result.addAll(sourceAttributes);
+		return result;
+	}
+
+	public Set<String> getSourceAttributesLowerCase(){
+		Set<String> result = new HashSet<>();
+		for(String attr : sourceAttributes){
+			if (attr != null){
+				result.add(attr.toLowerCase());
+			}else{
+				result.add(null);
+			}
+		}
+		return result;
+	}
+
+	public Set<String> getDestinationAttributes(){
+		Set<String> result = new HashSet<>();
+		result.addAll(destinationAttributes);
+		return result;
+	}
+
+	public List<String> getDestinationAttributeList(){
+		List<String> result = new ArrayList<>();
+		result.addAll(destinationAttributeList);
+		return result;
+	}
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmMapperBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmMapperBase.java
index 43de3b94e1..6e9cb2d4bf 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmMapperBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/CdmMapperBase.java
@@ -1,23 +1,25 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy 
-* http://www.e-taxonomy.eu
-* 
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-/**
- * The most general mapper class for all cdm mappers.
- * @author a.mueller
- * @since 12.01.2012
- */
-public abstract class CdmMapperBase {
-	@SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(CdmMapperBase.class);
-	
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+/**
+ * The most general mapper class for all cdm mappers.
+ * @author a.mueller
+ * @since 12.01.2012
+ */
+public abstract class CdmMapperBase {
+
+	@SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
+
 }
